// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from qb_device_msgs:msg/Info.idl
// generated code does not contain a copyright notice
#include "qb_device_msgs/msg/detail/info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `serial_port`
#include "rosidl_runtime_c/string_functions.h"
// Member `position_limits`
// Member `encoder_resolutions`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
qb_device_msgs__msg__Info__init(qb_device_msgs__msg__Info * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // serial_port
  if (!rosidl_runtime_c__String__init(&msg->serial_port)) {
    qb_device_msgs__msg__Info__fini(msg);
    return false;
  }
  // max_repeats
  // get_positions
  // get_currents
  // get_distinct_packages
  // set_commands
  // set_commands_async
  // position_limits
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->position_limits, 0)) {
    qb_device_msgs__msg__Info__fini(msg);
    return false;
  }
  // encoder_resolutions
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->encoder_resolutions, 0)) {
    qb_device_msgs__msg__Info__fini(msg);
    return false;
  }
  return true;
}

void
qb_device_msgs__msg__Info__fini(qb_device_msgs__msg__Info * msg)
{
  if (!msg) {
    return;
  }
  // id
  // serial_port
  rosidl_runtime_c__String__fini(&msg->serial_port);
  // max_repeats
  // get_positions
  // get_currents
  // get_distinct_packages
  // set_commands
  // set_commands_async
  // position_limits
  rosidl_runtime_c__int32__Sequence__fini(&msg->position_limits);
  // encoder_resolutions
  rosidl_runtime_c__uint8__Sequence__fini(&msg->encoder_resolutions);
}

bool
qb_device_msgs__msg__Info__are_equal(const qb_device_msgs__msg__Info * lhs, const qb_device_msgs__msg__Info * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // serial_port
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->serial_port), &(rhs->serial_port)))
  {
    return false;
  }
  // max_repeats
  if (lhs->max_repeats != rhs->max_repeats) {
    return false;
  }
  // get_positions
  if (lhs->get_positions != rhs->get_positions) {
    return false;
  }
  // get_currents
  if (lhs->get_currents != rhs->get_currents) {
    return false;
  }
  // get_distinct_packages
  if (lhs->get_distinct_packages != rhs->get_distinct_packages) {
    return false;
  }
  // set_commands
  if (lhs->set_commands != rhs->set_commands) {
    return false;
  }
  // set_commands_async
  if (lhs->set_commands_async != rhs->set_commands_async) {
    return false;
  }
  // position_limits
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->position_limits), &(rhs->position_limits)))
  {
    return false;
  }
  // encoder_resolutions
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->encoder_resolutions), &(rhs->encoder_resolutions)))
  {
    return false;
  }
  return true;
}

bool
qb_device_msgs__msg__Info__copy(
  const qb_device_msgs__msg__Info * input,
  qb_device_msgs__msg__Info * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // serial_port
  if (!rosidl_runtime_c__String__copy(
      &(input->serial_port), &(output->serial_port)))
  {
    return false;
  }
  // max_repeats
  output->max_repeats = input->max_repeats;
  // get_positions
  output->get_positions = input->get_positions;
  // get_currents
  output->get_currents = input->get_currents;
  // get_distinct_packages
  output->get_distinct_packages = input->get_distinct_packages;
  // set_commands
  output->set_commands = input->set_commands;
  // set_commands_async
  output->set_commands_async = input->set_commands_async;
  // position_limits
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->position_limits), &(output->position_limits)))
  {
    return false;
  }
  // encoder_resolutions
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->encoder_resolutions), &(output->encoder_resolutions)))
  {
    return false;
  }
  return true;
}

qb_device_msgs__msg__Info *
qb_device_msgs__msg__Info__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__msg__Info * msg = (qb_device_msgs__msg__Info *)allocator.allocate(sizeof(qb_device_msgs__msg__Info), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_device_msgs__msg__Info));
  bool success = qb_device_msgs__msg__Info__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_device_msgs__msg__Info__destroy(qb_device_msgs__msg__Info * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_device_msgs__msg__Info__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_device_msgs__msg__Info__Sequence__init(qb_device_msgs__msg__Info__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__msg__Info * data = NULL;

  if (size) {
    data = (qb_device_msgs__msg__Info *)allocator.zero_allocate(size, sizeof(qb_device_msgs__msg__Info), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_device_msgs__msg__Info__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_device_msgs__msg__Info__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_device_msgs__msg__Info__Sequence__fini(qb_device_msgs__msg__Info__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_device_msgs__msg__Info__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_device_msgs__msg__Info__Sequence *
qb_device_msgs__msg__Info__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__msg__Info__Sequence * array = (qb_device_msgs__msg__Info__Sequence *)allocator.allocate(sizeof(qb_device_msgs__msg__Info__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_device_msgs__msg__Info__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_device_msgs__msg__Info__Sequence__destroy(qb_device_msgs__msg__Info__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_device_msgs__msg__Info__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_device_msgs__msg__Info__Sequence__are_equal(const qb_device_msgs__msg__Info__Sequence * lhs, const qb_device_msgs__msg__Info__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_device_msgs__msg__Info__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_device_msgs__msg__Info__Sequence__copy(
  const qb_device_msgs__msg__Info__Sequence * input,
  qb_device_msgs__msg__Info__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_device_msgs__msg__Info);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_device_msgs__msg__Info * data =
      (qb_device_msgs__msg__Info *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_device_msgs__msg__Info__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_device_msgs__msg__Info__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_device_msgs__msg__Info__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
