// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_device_msgs:msg/Info.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__INFO__STRUCT_HPP_
#define QB_DEVICE_MSGS__MSG__DETAIL__INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__qb_device_msgs__msg__Info __attribute__((deprecated))
#else
# define DEPRECATED__qb_device_msgs__msg__Info __declspec(deprecated)
#endif

namespace qb_device_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Info_
{
  using Type = Info_<ContainerAllocator>;

  explicit Info_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->serial_port = "";
      this->max_repeats = 0l;
      this->get_positions = false;
      this->get_currents = false;
      this->get_distinct_packages = false;
      this->set_commands = false;
      this->set_commands_async = false;
    }
  }

  explicit Info_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : serial_port(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->serial_port = "";
      this->max_repeats = 0l;
      this->get_positions = false;
      this->get_currents = false;
      this->get_distinct_packages = false;
      this->set_commands = false;
      this->set_commands_async = false;
    }
  }

  // field types and members
  using _id_type =
    int32_t;
  _id_type id;
  using _serial_port_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _serial_port_type serial_port;
  using _max_repeats_type =
    int32_t;
  _max_repeats_type max_repeats;
  using _get_positions_type =
    bool;
  _get_positions_type get_positions;
  using _get_currents_type =
    bool;
  _get_currents_type get_currents;
  using _get_distinct_packages_type =
    bool;
  _get_distinct_packages_type get_distinct_packages;
  using _set_commands_type =
    bool;
  _set_commands_type set_commands;
  using _set_commands_async_type =
    bool;
  _set_commands_async_type set_commands_async;
  using _position_limits_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _position_limits_type position_limits;
  using _encoder_resolutions_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _encoder_resolutions_type encoder_resolutions;

  // setters for named parameter idiom
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__serial_port(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->serial_port = _arg;
    return *this;
  }
  Type & set__max_repeats(
    const int32_t & _arg)
  {
    this->max_repeats = _arg;
    return *this;
  }
  Type & set__get_positions(
    const bool & _arg)
  {
    this->get_positions = _arg;
    return *this;
  }
  Type & set__get_currents(
    const bool & _arg)
  {
    this->get_currents = _arg;
    return *this;
  }
  Type & set__get_distinct_packages(
    const bool & _arg)
  {
    this->get_distinct_packages = _arg;
    return *this;
  }
  Type & set__set_commands(
    const bool & _arg)
  {
    this->set_commands = _arg;
    return *this;
  }
  Type & set__set_commands_async(
    const bool & _arg)
  {
    this->set_commands_async = _arg;
    return *this;
  }
  Type & set__position_limits(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->position_limits = _arg;
    return *this;
  }
  Type & set__encoder_resolutions(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->encoder_resolutions = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_device_msgs::msg::Info_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_device_msgs::msg::Info_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_device_msgs::msg::Info_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_device_msgs::msg::Info_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::msg::Info_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::msg::Info_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::msg::Info_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::msg::Info_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_device_msgs::msg::Info_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_device_msgs::msg::Info_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_device_msgs__msg__Info
    std::shared_ptr<qb_device_msgs::msg::Info_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_device_msgs__msg__Info
    std::shared_ptr<qb_device_msgs::msg::Info_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Info_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->serial_port != other.serial_port) {
      return false;
    }
    if (this->max_repeats != other.max_repeats) {
      return false;
    }
    if (this->get_positions != other.get_positions) {
      return false;
    }
    if (this->get_currents != other.get_currents) {
      return false;
    }
    if (this->get_distinct_packages != other.get_distinct_packages) {
      return false;
    }
    if (this->set_commands != other.set_commands) {
      return false;
    }
    if (this->set_commands_async != other.set_commands_async) {
      return false;
    }
    if (this->position_limits != other.position_limits) {
      return false;
    }
    if (this->encoder_resolutions != other.encoder_resolutions) {
      return false;
    }
    return true;
  }
  bool operator!=(const Info_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Info_

// alias to use template instance with default allocator
using Info =
  qb_device_msgs::msg::Info_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace qb_device_msgs

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__INFO__STRUCT_HPP_
