// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_device_msgs:msg/State.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__STATE__STRUCT_HPP_
#define QB_DEVICE_MSGS__MSG__DETAIL__STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'actuators'
// Member 'joints'
#include "qb_device_msgs/msg/detail/resource_data__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__qb_device_msgs__msg__State __attribute__((deprecated))
#else
# define DEPRECATED__qb_device_msgs__msg__State __declspec(deprecated)
#endif

namespace qb_device_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct State_
{
  using Type = State_<ContainerAllocator>;

  explicit State_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_reliable = false;
      this->consecutive_failures = 0l;
    }
  }

  explicit State_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_reliable = false;
      this->consecutive_failures = 0l;
    }
  }

  // field types and members
  using _actuators_type =
    std::vector<qb_device_msgs::msg::ResourceData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<qb_device_msgs::msg::ResourceData_<ContainerAllocator>>>;
  _actuators_type actuators;
  using _joints_type =
    std::vector<qb_device_msgs::msg::ResourceData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<qb_device_msgs::msg::ResourceData_<ContainerAllocator>>>;
  _joints_type joints;
  using _is_reliable_type =
    bool;
  _is_reliable_type is_reliable;
  using _consecutive_failures_type =
    int32_t;
  _consecutive_failures_type consecutive_failures;

  // setters for named parameter idiom
  Type & set__actuators(
    const std::vector<qb_device_msgs::msg::ResourceData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<qb_device_msgs::msg::ResourceData_<ContainerAllocator>>> & _arg)
  {
    this->actuators = _arg;
    return *this;
  }
  Type & set__joints(
    const std::vector<qb_device_msgs::msg::ResourceData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<qb_device_msgs::msg::ResourceData_<ContainerAllocator>>> & _arg)
  {
    this->joints = _arg;
    return *this;
  }
  Type & set__is_reliable(
    const bool & _arg)
  {
    this->is_reliable = _arg;
    return *this;
  }
  Type & set__consecutive_failures(
    const int32_t & _arg)
  {
    this->consecutive_failures = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_device_msgs::msg::State_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_device_msgs::msg::State_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_device_msgs::msg::State_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_device_msgs::msg::State_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::msg::State_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::msg::State_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::msg::State_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::msg::State_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_device_msgs::msg::State_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_device_msgs::msg::State_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_device_msgs__msg__State
    std::shared_ptr<qb_device_msgs::msg::State_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_device_msgs__msg__State
    std::shared_ptr<qb_device_msgs::msg::State_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const State_ & other) const
  {
    if (this->actuators != other.actuators) {
      return false;
    }
    if (this->joints != other.joints) {
      return false;
    }
    if (this->is_reliable != other.is_reliable) {
      return false;
    }
    if (this->consecutive_failures != other.consecutive_failures) {
      return false;
    }
    return true;
  }
  bool operator!=(const State_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct State_

// alias to use template instance with default allocator
using State =
  qb_device_msgs::msg::State_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace qb_device_msgs

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__STATE__STRUCT_HPP_
