// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:msg/State.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
#define QB_DEVICE_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/msg/detail/state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'actuators'
// Member 'joints'
#include "qb_device_msgs/msg/detail/resource_data__traits.hpp"

namespace qb_device_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const State & msg,
  std::ostream & out)
{
  out << "{";
  // member: actuators
  {
    if (msg.actuators.size() == 0) {
      out << "actuators: []";
    } else {
      out << "actuators: [";
      size_t pending_items = msg.actuators.size();
      for (auto item : msg.actuators) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: joints
  {
    if (msg.joints.size() == 0) {
      out << "joints: []";
    } else {
      out << "joints: [";
      size_t pending_items = msg.joints.size();
      for (auto item : msg.joints) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: is_reliable
  {
    out << "is_reliable: ";
    rosidl_generator_traits::value_to_yaml(msg.is_reliable, out);
    out << ", ";
  }

  // member: consecutive_failures
  {
    out << "consecutive_failures: ";
    rosidl_generator_traits::value_to_yaml(msg.consecutive_failures, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const State & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: actuators
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.actuators.size() == 0) {
      out << "actuators: []\n";
    } else {
      out << "actuators:\n";
      for (auto item : msg.actuators) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: joints
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.joints.size() == 0) {
      out << "joints: []\n";
    } else {
      out << "joints:\n";
      for (auto item : msg.joints) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: is_reliable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_reliable: ";
    rosidl_generator_traits::value_to_yaml(msg.is_reliable, out);
    out << "\n";
  }

  // member: consecutive_failures
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "consecutive_failures: ";
    rosidl_generator_traits::value_to_yaml(msg.consecutive_failures, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const State & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::msg::State & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::msg::State & msg)
{
  return qb_device_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::msg::State>()
{
  return "qb_device_msgs::msg::State";
}

template<>
inline const char * name<qb_device_msgs::msg::State>()
{
  return "qb_device_msgs/msg/State";
}

template<>
struct has_fixed_size<qb_device_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_device_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_device_msgs::msg::State>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
