// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from qb_device_msgs:srv/GetMeasurements.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_H_
#define QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/GetMeasurements in the package qb_device_msgs.
typedef struct qb_device_msgs__srv__GetMeasurements_Request
{
  int32_t id;
  int32_t max_repeats;
  bool get_positions;
  bool get_currents;
  bool get_commands;
} qb_device_msgs__srv__GetMeasurements_Request;

// Struct for a sequence of qb_device_msgs__srv__GetMeasurements_Request.
typedef struct qb_device_msgs__srv__GetMeasurements_Request__Sequence
{
  qb_device_msgs__srv__GetMeasurements_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} qb_device_msgs__srv__GetMeasurements_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'positions'
// Member 'currents'
// Member 'commands'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in srv/GetMeasurements in the package qb_device_msgs.
typedef struct qb_device_msgs__srv__GetMeasurements_Response
{
  bool success;
  int32_t failures;
  rosidl_runtime_c__int16__Sequence positions;
  rosidl_runtime_c__int16__Sequence currents;
  rosidl_runtime_c__int16__Sequence commands;
  builtin_interfaces__msg__Time stamp;
} qb_device_msgs__srv__GetMeasurements_Response;

// Struct for a sequence of qb_device_msgs__srv__GetMeasurements_Response.
typedef struct qb_device_msgs__srv__GetMeasurements_Response__Sequence
{
  qb_device_msgs__srv__GetMeasurements_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} qb_device_msgs__srv__GetMeasurements_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_H_
