// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:srv/GetMeasurements.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__TRAITS_HPP_
#define QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/srv/detail/get_measurements__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_device_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetMeasurements_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: max_repeats
  {
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << ", ";
  }

  // member: get_positions
  {
    out << "get_positions: ";
    rosidl_generator_traits::value_to_yaml(msg.get_positions, out);
    out << ", ";
  }

  // member: get_currents
  {
    out << "get_currents: ";
    rosidl_generator_traits::value_to_yaml(msg.get_currents, out);
    out << ", ";
  }

  // member: get_commands
  {
    out << "get_commands: ";
    rosidl_generator_traits::value_to_yaml(msg.get_commands, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetMeasurements_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: max_repeats
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << "\n";
  }

  // member: get_positions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_positions: ";
    rosidl_generator_traits::value_to_yaml(msg.get_positions, out);
    out << "\n";
  }

  // member: get_currents
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_currents: ";
    rosidl_generator_traits::value_to_yaml(msg.get_currents, out);
    out << "\n";
  }

  // member: get_commands
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_commands: ";
    rosidl_generator_traits::value_to_yaml(msg.get_commands, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetMeasurements_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::srv::GetMeasurements_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::srv::GetMeasurements_Request & msg)
{
  return qb_device_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::srv::GetMeasurements_Request>()
{
  return "qb_device_msgs::srv::GetMeasurements_Request";
}

template<>
inline const char * name<qb_device_msgs::srv::GetMeasurements_Request>()
{
  return "qb_device_msgs/srv/GetMeasurements_Request";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::GetMeasurements_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<qb_device_msgs::srv::GetMeasurements_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<qb_device_msgs::srv::GetMeasurements_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace qb_device_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetMeasurements_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: failures
  {
    out << "failures: ";
    rosidl_generator_traits::value_to_yaml(msg.failures, out);
    out << ", ";
  }

  // member: positions
  {
    if (msg.positions.size() == 0) {
      out << "positions: []";
    } else {
      out << "positions: [";
      size_t pending_items = msg.positions.size();
      for (auto item : msg.positions) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: currents
  {
    if (msg.currents.size() == 0) {
      out << "currents: []";
    } else {
      out << "currents: [";
      size_t pending_items = msg.currents.size();
      for (auto item : msg.currents) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: commands
  {
    if (msg.commands.size() == 0) {
      out << "commands: []";
    } else {
      out << "commands: [";
      size_t pending_items = msg.commands.size();
      for (auto item : msg.commands) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetMeasurements_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: failures
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "failures: ";
    rosidl_generator_traits::value_to_yaml(msg.failures, out);
    out << "\n";
  }

  // member: positions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.positions.size() == 0) {
      out << "positions: []\n";
    } else {
      out << "positions:\n";
      for (auto item : msg.positions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: currents
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.currents.size() == 0) {
      out << "currents: []\n";
    } else {
      out << "currents:\n";
      for (auto item : msg.currents) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: commands
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.commands.size() == 0) {
      out << "commands: []\n";
    } else {
      out << "commands:\n";
      for (auto item : msg.commands) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetMeasurements_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::srv::GetMeasurements_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::srv::GetMeasurements_Response & msg)
{
  return qb_device_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::srv::GetMeasurements_Response>()
{
  return "qb_device_msgs::srv::GetMeasurements_Response";
}

template<>
inline const char * name<qb_device_msgs::srv::GetMeasurements_Response>()
{
  return "qb_device_msgs/srv/GetMeasurements_Response";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::GetMeasurements_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_device_msgs::srv::GetMeasurements_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_device_msgs::srv::GetMeasurements_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<qb_device_msgs::srv::GetMeasurements>()
{
  return "qb_device_msgs::srv::GetMeasurements";
}

template<>
inline const char * name<qb_device_msgs::srv::GetMeasurements>()
{
  return "qb_device_msgs/srv/GetMeasurements";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::GetMeasurements>
  : std::integral_constant<
    bool,
    has_fixed_size<qb_device_msgs::srv::GetMeasurements_Request>::value &&
    has_fixed_size<qb_device_msgs::srv::GetMeasurements_Response>::value
  >
{
};

template<>
struct has_bounded_size<qb_device_msgs::srv::GetMeasurements>
  : std::integral_constant<
    bool,
    has_bounded_size<qb_device_msgs::srv::GetMeasurements_Request>::value &&
    has_bounded_size<qb_device_msgs::srv::GetMeasurements_Response>::value
  >
{
};

template<>
struct is_service<qb_device_msgs::srv::GetMeasurements>
  : std::true_type
{
};

template<>
struct is_service_request<qb_device_msgs::srv::GetMeasurements_Request>
  : std::true_type
{
};

template<>
struct is_service_response<qb_device_msgs::srv::GetMeasurements_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__TRAITS_HPP_
