// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from qb_device_msgs:srv/SetCommands.idl
// generated code does not contain a copyright notice
#include "qb_device_msgs/srv/detail/set_commands__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `commands`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
qb_device_msgs__srv__SetCommands_Request__init(qb_device_msgs__srv__SetCommands_Request * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // max_repeats
  // set_commands
  // set_commands_async
  // commands
  if (!rosidl_runtime_c__int16__Sequence__init(&msg->commands, 0)) {
    qb_device_msgs__srv__SetCommands_Request__fini(msg);
    return false;
  }
  return true;
}

void
qb_device_msgs__srv__SetCommands_Request__fini(qb_device_msgs__srv__SetCommands_Request * msg)
{
  if (!msg) {
    return;
  }
  // id
  // max_repeats
  // set_commands
  // set_commands_async
  // commands
  rosidl_runtime_c__int16__Sequence__fini(&msg->commands);
}

bool
qb_device_msgs__srv__SetCommands_Request__are_equal(const qb_device_msgs__srv__SetCommands_Request * lhs, const qb_device_msgs__srv__SetCommands_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // max_repeats
  if (lhs->max_repeats != rhs->max_repeats) {
    return false;
  }
  // set_commands
  if (lhs->set_commands != rhs->set_commands) {
    return false;
  }
  // set_commands_async
  if (lhs->set_commands_async != rhs->set_commands_async) {
    return false;
  }
  // commands
  if (!rosidl_runtime_c__int16__Sequence__are_equal(
      &(lhs->commands), &(rhs->commands)))
  {
    return false;
  }
  return true;
}

bool
qb_device_msgs__srv__SetCommands_Request__copy(
  const qb_device_msgs__srv__SetCommands_Request * input,
  qb_device_msgs__srv__SetCommands_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // max_repeats
  output->max_repeats = input->max_repeats;
  // set_commands
  output->set_commands = input->set_commands;
  // set_commands_async
  output->set_commands_async = input->set_commands_async;
  // commands
  if (!rosidl_runtime_c__int16__Sequence__copy(
      &(input->commands), &(output->commands)))
  {
    return false;
  }
  return true;
}

qb_device_msgs__srv__SetCommands_Request *
qb_device_msgs__srv__SetCommands_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__SetCommands_Request * msg = (qb_device_msgs__srv__SetCommands_Request *)allocator.allocate(sizeof(qb_device_msgs__srv__SetCommands_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_device_msgs__srv__SetCommands_Request));
  bool success = qb_device_msgs__srv__SetCommands_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_device_msgs__srv__SetCommands_Request__destroy(qb_device_msgs__srv__SetCommands_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_device_msgs__srv__SetCommands_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_device_msgs__srv__SetCommands_Request__Sequence__init(qb_device_msgs__srv__SetCommands_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__SetCommands_Request * data = NULL;

  if (size) {
    data = (qb_device_msgs__srv__SetCommands_Request *)allocator.zero_allocate(size, sizeof(qb_device_msgs__srv__SetCommands_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_device_msgs__srv__SetCommands_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_device_msgs__srv__SetCommands_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_device_msgs__srv__SetCommands_Request__Sequence__fini(qb_device_msgs__srv__SetCommands_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_device_msgs__srv__SetCommands_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_device_msgs__srv__SetCommands_Request__Sequence *
qb_device_msgs__srv__SetCommands_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__SetCommands_Request__Sequence * array = (qb_device_msgs__srv__SetCommands_Request__Sequence *)allocator.allocate(sizeof(qb_device_msgs__srv__SetCommands_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_device_msgs__srv__SetCommands_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_device_msgs__srv__SetCommands_Request__Sequence__destroy(qb_device_msgs__srv__SetCommands_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_device_msgs__srv__SetCommands_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_device_msgs__srv__SetCommands_Request__Sequence__are_equal(const qb_device_msgs__srv__SetCommands_Request__Sequence * lhs, const qb_device_msgs__srv__SetCommands_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_device_msgs__srv__SetCommands_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_device_msgs__srv__SetCommands_Request__Sequence__copy(
  const qb_device_msgs__srv__SetCommands_Request__Sequence * input,
  qb_device_msgs__srv__SetCommands_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_device_msgs__srv__SetCommands_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_device_msgs__srv__SetCommands_Request * data =
      (qb_device_msgs__srv__SetCommands_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_device_msgs__srv__SetCommands_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_device_msgs__srv__SetCommands_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_device_msgs__srv__SetCommands_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
qb_device_msgs__srv__SetCommands_Response__init(qb_device_msgs__srv__SetCommands_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // failures
  return true;
}

void
qb_device_msgs__srv__SetCommands_Response__fini(qb_device_msgs__srv__SetCommands_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // failures
}

bool
qb_device_msgs__srv__SetCommands_Response__are_equal(const qb_device_msgs__srv__SetCommands_Response * lhs, const qb_device_msgs__srv__SetCommands_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // failures
  if (lhs->failures != rhs->failures) {
    return false;
  }
  return true;
}

bool
qb_device_msgs__srv__SetCommands_Response__copy(
  const qb_device_msgs__srv__SetCommands_Response * input,
  qb_device_msgs__srv__SetCommands_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // failures
  output->failures = input->failures;
  return true;
}

qb_device_msgs__srv__SetCommands_Response *
qb_device_msgs__srv__SetCommands_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__SetCommands_Response * msg = (qb_device_msgs__srv__SetCommands_Response *)allocator.allocate(sizeof(qb_device_msgs__srv__SetCommands_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_device_msgs__srv__SetCommands_Response));
  bool success = qb_device_msgs__srv__SetCommands_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_device_msgs__srv__SetCommands_Response__destroy(qb_device_msgs__srv__SetCommands_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_device_msgs__srv__SetCommands_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_device_msgs__srv__SetCommands_Response__Sequence__init(qb_device_msgs__srv__SetCommands_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__SetCommands_Response * data = NULL;

  if (size) {
    data = (qb_device_msgs__srv__SetCommands_Response *)allocator.zero_allocate(size, sizeof(qb_device_msgs__srv__SetCommands_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_device_msgs__srv__SetCommands_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_device_msgs__srv__SetCommands_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_device_msgs__srv__SetCommands_Response__Sequence__fini(qb_device_msgs__srv__SetCommands_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_device_msgs__srv__SetCommands_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_device_msgs__srv__SetCommands_Response__Sequence *
qb_device_msgs__srv__SetCommands_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__SetCommands_Response__Sequence * array = (qb_device_msgs__srv__SetCommands_Response__Sequence *)allocator.allocate(sizeof(qb_device_msgs__srv__SetCommands_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_device_msgs__srv__SetCommands_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_device_msgs__srv__SetCommands_Response__Sequence__destroy(qb_device_msgs__srv__SetCommands_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_device_msgs__srv__SetCommands_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_device_msgs__srv__SetCommands_Response__Sequence__are_equal(const qb_device_msgs__srv__SetCommands_Response__Sequence * lhs, const qb_device_msgs__srv__SetCommands_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_device_msgs__srv__SetCommands_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_device_msgs__srv__SetCommands_Response__Sequence__copy(
  const qb_device_msgs__srv__SetCommands_Response__Sequence * input,
  qb_device_msgs__srv__SetCommands_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_device_msgs__srv__SetCommands_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_device_msgs__srv__SetCommands_Response * data =
      (qb_device_msgs__srv__SetCommands_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_device_msgs__srv__SetCommands_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_device_msgs__srv__SetCommands_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_device_msgs__srv__SetCommands_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
