// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from qb_device_msgs:msg/State.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__STATE__STRUCT_H_
#define QB_DEVICE_MSGS__MSG__DETAIL__STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'actuators'
// Member 'joints'
#include "qb_device_msgs/msg/detail/resource_data__struct.h"

/// Struct defined in msg/State in the package qb_device_msgs.
/**
  * State message valid for either qbhand or qbmove
 */
typedef struct qb_device_msgs__msg__State
{
  /// either qbhand or qbmove:
  ///  - motors: position, command in [ticks], velocity in [ticks/s], effort in [mA]
  qb_device_msgs__msg__ResourceData__Sequence actuators;
  /// qbhand:
  ///  - closure: position, command in [0,1], velocity in [percent/s],  effort in [A].
  /// qbmove:
  ///  - shaft: position, command in [radians], velocity in [radians/s], effort in [A];
  ///  - preset: position, command in [0,1], velocity in [percent/s], effort is not used.
  qb_device_msgs__msg__ResourceData__Sequence joints;
  /// Reliability of the retrieved measurements
  bool is_reliable;
  int32_t consecutive_failures;
} qb_device_msgs__msg__State;

// Struct for a sequence of qb_device_msgs__msg__State.
typedef struct qb_device_msgs__msg__State__Sequence
{
  qb_device_msgs__msg__State * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} qb_device_msgs__msg__State__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__STATE__STRUCT_H_
