// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from qb_device_msgs:msg/StateStamped.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__STATE_STAMPED__FUNCTIONS_H_
#define QB_DEVICE_MSGS__MSG__DETAIL__STATE_STAMPED__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "qb_device_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "qb_device_msgs/msg/detail/state_stamped__struct.h"

/// Initialize msg/StateStamped message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * qb_device_msgs__msg__StateStamped
 * )) before or use
 * qb_device_msgs__msg__StateStamped__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
bool
qb_device_msgs__msg__StateStamped__init(qb_device_msgs__msg__StateStamped * msg);

/// Finalize msg/StateStamped message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
void
qb_device_msgs__msg__StateStamped__fini(qb_device_msgs__msg__StateStamped * msg);

/// Create msg/StateStamped message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * qb_device_msgs__msg__StateStamped__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
qb_device_msgs__msg__StateStamped *
qb_device_msgs__msg__StateStamped__create();

/// Destroy msg/StateStamped message.
/**
 * It calls
 * qb_device_msgs__msg__StateStamped__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
void
qb_device_msgs__msg__StateStamped__destroy(qb_device_msgs__msg__StateStamped * msg);

/// Check for msg/StateStamped message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
bool
qb_device_msgs__msg__StateStamped__are_equal(const qb_device_msgs__msg__StateStamped * lhs, const qb_device_msgs__msg__StateStamped * rhs);

/// Copy a msg/StateStamped message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
bool
qb_device_msgs__msg__StateStamped__copy(
  const qb_device_msgs__msg__StateStamped * input,
  qb_device_msgs__msg__StateStamped * output);

/// Initialize array of msg/StateStamped messages.
/**
 * It allocates the memory for the number of elements and calls
 * qb_device_msgs__msg__StateStamped__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
bool
qb_device_msgs__msg__StateStamped__Sequence__init(qb_device_msgs__msg__StateStamped__Sequence * array, size_t size);

/// Finalize array of msg/StateStamped messages.
/**
 * It calls
 * qb_device_msgs__msg__StateStamped__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
void
qb_device_msgs__msg__StateStamped__Sequence__fini(qb_device_msgs__msg__StateStamped__Sequence * array);

/// Create array of msg/StateStamped messages.
/**
 * It allocates the memory for the array and calls
 * qb_device_msgs__msg__StateStamped__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
qb_device_msgs__msg__StateStamped__Sequence *
qb_device_msgs__msg__StateStamped__Sequence__create(size_t size);

/// Destroy array of msg/StateStamped messages.
/**
 * It calls
 * qb_device_msgs__msg__StateStamped__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
void
qb_device_msgs__msg__StateStamped__Sequence__destroy(qb_device_msgs__msg__StateStamped__Sequence * array);

/// Check for msg/StateStamped message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
bool
qb_device_msgs__msg__StateStamped__Sequence__are_equal(const qb_device_msgs__msg__StateStamped__Sequence * lhs, const qb_device_msgs__msg__StateStamped__Sequence * rhs);

/// Copy an array of msg/StateStamped messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_device_msgs
bool
qb_device_msgs__msg__StateStamped__Sequence__copy(
  const qb_device_msgs__msg__StateStamped__Sequence * input,
  qb_device_msgs__msg__StateStamped__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__STATE_STAMPED__FUNCTIONS_H_
