// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:msg/StateStamped.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__STATE_STAMPED__TRAITS_HPP_
#define QB_DEVICE_MSGS__MSG__DETAIL__STATE_STAMPED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/msg/detail/state_stamped__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'device_info'
#include "qb_device_msgs/msg/detail/info__traits.hpp"
// Member 'device_data'
#include "qb_device_msgs/msg/detail/state__traits.hpp"

namespace qb_device_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const StateStamped & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: device_info
  {
    out << "device_info: ";
    to_flow_style_yaml(msg.device_info, out);
    out << ", ";
  }

  // member: device_data
  {
    out << "device_data: ";
    to_flow_style_yaml(msg.device_data, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StateStamped & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: device_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_info:\n";
    to_block_style_yaml(msg.device_info, out, indentation + 2);
  }

  // member: device_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_data:\n";
    to_block_style_yaml(msg.device_data, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StateStamped & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::msg::StateStamped & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::msg::StateStamped & msg)
{
  return qb_device_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::msg::StateStamped>()
{
  return "qb_device_msgs::msg::StateStamped";
}

template<>
inline const char * name<qb_device_msgs::msg::StateStamped>()
{
  return "qb_device_msgs/msg/StateStamped";
}

template<>
struct has_fixed_size<qb_device_msgs::msg::StateStamped>
  : std::integral_constant<bool, has_fixed_size<qb_device_msgs::msg::Info>::value && has_fixed_size<qb_device_msgs::msg::State>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<qb_device_msgs::msg::StateStamped>
  : std::integral_constant<bool, has_bounded_size<qb_device_msgs::msg::Info>::value && has_bounded_size<qb_device_msgs::msg::State>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<qb_device_msgs::msg::StateStamped>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__STATE_STAMPED__TRAITS_HPP_
