// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_device_msgs:srv/GetMeasurements.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_HPP_
#define QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__qb_device_msgs__srv__GetMeasurements_Request __attribute__((deprecated))
#else
# define DEPRECATED__qb_device_msgs__srv__GetMeasurements_Request __declspec(deprecated)
#endif

namespace qb_device_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMeasurements_Request_
{
  using Type = GetMeasurements_Request_<ContainerAllocator>;

  explicit GetMeasurements_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->max_repeats = 0l;
      this->get_positions = false;
      this->get_currents = false;
      this->get_commands = false;
    }
  }

  explicit GetMeasurements_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->max_repeats = 0l;
      this->get_positions = false;
      this->get_currents = false;
      this->get_commands = false;
    }
  }

  // field types and members
  using _id_type =
    int32_t;
  _id_type id;
  using _max_repeats_type =
    int32_t;
  _max_repeats_type max_repeats;
  using _get_positions_type =
    bool;
  _get_positions_type get_positions;
  using _get_currents_type =
    bool;
  _get_currents_type get_currents;
  using _get_commands_type =
    bool;
  _get_commands_type get_commands;

  // setters for named parameter idiom
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__max_repeats(
    const int32_t & _arg)
  {
    this->max_repeats = _arg;
    return *this;
  }
  Type & set__get_positions(
    const bool & _arg)
  {
    this->get_positions = _arg;
    return *this;
  }
  Type & set__get_currents(
    const bool & _arg)
  {
    this->get_currents = _arg;
    return *this;
  }
  Type & set__get_commands(
    const bool & _arg)
  {
    this->get_commands = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_device_msgs__srv__GetMeasurements_Request
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_device_msgs__srv__GetMeasurements_Request
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMeasurements_Request_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->max_repeats != other.max_repeats) {
      return false;
    }
    if (this->get_positions != other.get_positions) {
      return false;
    }
    if (this->get_currents != other.get_currents) {
      return false;
    }
    if (this->get_commands != other.get_commands) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMeasurements_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMeasurements_Request_

// alias to use template instance with default allocator
using GetMeasurements_Request =
  qb_device_msgs::srv::GetMeasurements_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_device_msgs


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__qb_device_msgs__srv__GetMeasurements_Response __attribute__((deprecated))
#else
# define DEPRECATED__qb_device_msgs__srv__GetMeasurements_Response __declspec(deprecated)
#endif

namespace qb_device_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMeasurements_Response_
{
  using Type = GetMeasurements_Response_<ContainerAllocator>;

  explicit GetMeasurements_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->failures = 0l;
    }
  }

  explicit GetMeasurements_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->failures = 0l;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _failures_type =
    int32_t;
  _failures_type failures;
  using _positions_type =
    std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>>;
  _positions_type positions;
  using _currents_type =
    std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>>;
  _currents_type currents;
  using _commands_type =
    std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>>;
  _commands_type commands;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__failures(
    const int32_t & _arg)
  {
    this->failures = _arg;
    return *this;
  }
  Type & set__positions(
    const std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>> & _arg)
  {
    this->positions = _arg;
    return *this;
  }
  Type & set__currents(
    const std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>> & _arg)
  {
    this->currents = _arg;
    return *this;
  }
  Type & set__commands(
    const std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>> & _arg)
  {
    this->commands = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_device_msgs__srv__GetMeasurements_Response
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_device_msgs__srv__GetMeasurements_Response
    std::shared_ptr<qb_device_msgs::srv::GetMeasurements_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMeasurements_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->failures != other.failures) {
      return false;
    }
    if (this->positions != other.positions) {
      return false;
    }
    if (this->currents != other.currents) {
      return false;
    }
    if (this->commands != other.commands) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMeasurements_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMeasurements_Response_

// alias to use template instance with default allocator
using GetMeasurements_Response =
  qb_device_msgs::srv::GetMeasurements_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_device_msgs

namespace qb_device_msgs
{

namespace srv
{

struct GetMeasurements
{
  using Request = qb_device_msgs::srv::GetMeasurements_Request;
  using Response = qb_device_msgs::srv::GetMeasurements_Response;
};

}  // namespace srv

}  // namespace qb_device_msgs

#endif  // QB_DEVICE_MSGS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_HPP_
