// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:srv/InitializeDevice.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__SRV__DETAIL__INITIALIZE_DEVICE__TRAITS_HPP_
#define QB_DEVICE_MSGS__SRV__DETAIL__INITIALIZE_DEVICE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/srv/detail/initialize_device__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_device_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const InitializeDevice_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: activate
  {
    out << "activate: ";
    rosidl_generator_traits::value_to_yaml(msg.activate, out);
    out << ", ";
  }

  // member: rescan
  {
    out << "rescan: ";
    rosidl_generator_traits::value_to_yaml(msg.rescan, out);
    out << ", ";
  }

  // member: max_repeats
  {
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InitializeDevice_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: activate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "activate: ";
    rosidl_generator_traits::value_to_yaml(msg.activate, out);
    out << "\n";
  }

  // member: rescan
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rescan: ";
    rosidl_generator_traits::value_to_yaml(msg.rescan, out);
    out << "\n";
  }

  // member: max_repeats
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InitializeDevice_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::srv::InitializeDevice_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::srv::InitializeDevice_Request & msg)
{
  return qb_device_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::srv::InitializeDevice_Request>()
{
  return "qb_device_msgs::srv::InitializeDevice_Request";
}

template<>
inline const char * name<qb_device_msgs::srv::InitializeDevice_Request>()
{
  return "qb_device_msgs/srv/InitializeDevice_Request";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::InitializeDevice_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<qb_device_msgs::srv::InitializeDevice_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<qb_device_msgs::srv::InitializeDevice_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "qb_device_msgs/msg/detail/info__traits.hpp"

namespace qb_device_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const InitializeDevice_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: failures
  {
    out << "failures: ";
    rosidl_generator_traits::value_to_yaml(msg.failures, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << ", ";
  }

  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InitializeDevice_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: failures
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "failures: ";
    rosidl_generator_traits::value_to_yaml(msg.failures, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }

  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InitializeDevice_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::srv::InitializeDevice_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::srv::InitializeDevice_Response & msg)
{
  return qb_device_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::srv::InitializeDevice_Response>()
{
  return "qb_device_msgs::srv::InitializeDevice_Response";
}

template<>
inline const char * name<qb_device_msgs::srv::InitializeDevice_Response>()
{
  return "qb_device_msgs/srv/InitializeDevice_Response";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::InitializeDevice_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_device_msgs::srv::InitializeDevice_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_device_msgs::srv::InitializeDevice_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<qb_device_msgs::srv::InitializeDevice>()
{
  return "qb_device_msgs::srv::InitializeDevice";
}

template<>
inline const char * name<qb_device_msgs::srv::InitializeDevice>()
{
  return "qb_device_msgs/srv/InitializeDevice";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::InitializeDevice>
  : std::integral_constant<
    bool,
    has_fixed_size<qb_device_msgs::srv::InitializeDevice_Request>::value &&
    has_fixed_size<qb_device_msgs::srv::InitializeDevice_Response>::value
  >
{
};

template<>
struct has_bounded_size<qb_device_msgs::srv::InitializeDevice>
  : std::integral_constant<
    bool,
    has_bounded_size<qb_device_msgs::srv::InitializeDevice_Request>::value &&
    has_bounded_size<qb_device_msgs::srv::InitializeDevice_Response>::value
  >
{
};

template<>
struct is_service<qb_device_msgs::srv::InitializeDevice>
  : std::true_type
{
};

template<>
struct is_service_request<qb_device_msgs::srv::InitializeDevice_Request>
  : std::true_type
{
};

template<>
struct is_service_response<qb_device_msgs::srv::InitializeDevice_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__SRV__DETAIL__INITIALIZE_DEVICE__TRAITS_HPP_
