// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:srv/SetPid.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__SRV__DETAIL__SET_PID__TRAITS_HPP_
#define QB_DEVICE_MSGS__SRV__DETAIL__SET_PID__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/srv/detail/set_pid__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_device_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetPid_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: max_repeats
  {
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << ", ";
  }

  // member: p
  {
    out << "p: ";
    rosidl_generator_traits::value_to_yaml(msg.p, out);
    out << ", ";
  }

  // member: i
  {
    out << "i: ";
    rosidl_generator_traits::value_to_yaml(msg.i, out);
    out << ", ";
  }

  // member: d
  {
    out << "d: ";
    rosidl_generator_traits::value_to_yaml(msg.d, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetPid_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: max_repeats
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << "\n";
  }

  // member: p
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "p: ";
    rosidl_generator_traits::value_to_yaml(msg.p, out);
    out << "\n";
  }

  // member: i
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "i: ";
    rosidl_generator_traits::value_to_yaml(msg.i, out);
    out << "\n";
  }

  // member: d
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "d: ";
    rosidl_generator_traits::value_to_yaml(msg.d, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetPid_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::srv::SetPid_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::srv::SetPid_Request & msg)
{
  return qb_device_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::srv::SetPid_Request>()
{
  return "qb_device_msgs::srv::SetPid_Request";
}

template<>
inline const char * name<qb_device_msgs::srv::SetPid_Request>()
{
  return "qb_device_msgs/srv/SetPid_Request";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::SetPid_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<qb_device_msgs::srv::SetPid_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<qb_device_msgs::srv::SetPid_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace qb_device_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetPid_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: failures
  {
    out << "failures: ";
    rosidl_generator_traits::value_to_yaml(msg.failures, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetPid_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: failures
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "failures: ";
    rosidl_generator_traits::value_to_yaml(msg.failures, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetPid_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::srv::SetPid_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::srv::SetPid_Response & msg)
{
  return qb_device_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::srv::SetPid_Response>()
{
  return "qb_device_msgs::srv::SetPid_Response";
}

template<>
inline const char * name<qb_device_msgs::srv::SetPid_Response>()
{
  return "qb_device_msgs/srv/SetPid_Response";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::SetPid_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<qb_device_msgs::srv::SetPid_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<qb_device_msgs::srv::SetPid_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<qb_device_msgs::srv::SetPid>()
{
  return "qb_device_msgs::srv::SetPid";
}

template<>
inline const char * name<qb_device_msgs::srv::SetPid>()
{
  return "qb_device_msgs/srv/SetPid";
}

template<>
struct has_fixed_size<qb_device_msgs::srv::SetPid>
  : std::integral_constant<
    bool,
    has_fixed_size<qb_device_msgs::srv::SetPid_Request>::value &&
    has_fixed_size<qb_device_msgs::srv::SetPid_Response>::value
  >
{
};

template<>
struct has_bounded_size<qb_device_msgs::srv::SetPid>
  : std::integral_constant<
    bool,
    has_bounded_size<qb_device_msgs::srv::SetPid_Request>::value &&
    has_bounded_size<qb_device_msgs::srv::SetPid_Response>::value
  >
{
};

template<>
struct is_service<qb_device_msgs::srv::SetPid>
  : std::true_type
{
};

template<>
struct is_service_request<qb_device_msgs::srv::SetPid_Request>
  : std::true_type
{
};

template<>
struct is_service_response<qb_device_msgs::srv::SetPid_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__SRV__DETAIL__SET_PID__TRAITS_HPP_
